#ifndef JAC_H
#define JAC_H

// Kummer
static const unsigned char M01[16] = {0xd2, 0x58, 0x66, 0x36,
                                        0x9f, 0xed, 0x5c, 0x45,
                                        0x1b, 0xa7, 0xaa, 0x90,
                                        0xbd, 0xab, 0x88, 0x1c};
static const unsigned char M02[16] = {0x33, 0xde, 0x4c, 0x02,
                                        0x8c, 0xef, 0x20, 0x0f,
                                        0xe5, 0x59, 0xa5, 0x1e,
                                        0xf5, 0xe3, 0x70, 0x37};
static const unsigned char M03[16] = {0x62, 0xf5, 0x7f, 0x62,
                                       0xa4, 0x99, 0x30, 0x4e, 
                                       0x8d, 0x52, 0x05, 0x19,
                                       0x2c, 0xc6, 0x4a, 0x7a};
static const unsigned char M10[16] = {0x7a, 0x84, 0x4c, 0x1c,
                                        0x5e, 0x91, 0xf1, 0xbc,
                                        0xba, 0x8a, 0xf8, 0xf1,
                                        0x56, 0x1f, 0x9a, 0x28};
static const unsigned char M11[16] = {0xc2, 0xbd, 0xd9, 0xf1,
                                        0x50, 0x37, 0x87, 0xa1,
                                        0xa2, 0xba, 0x03, 0x87,
                                        0x54, 0xf0, 0xb2, 0x6b};
static const unsigned char M12[16] = {0xb2, 0x4c, 0x2c, 0x7c,
                                        0x36, 0x39, 0xcf, 0x95,
                                        0x79, 0xff, 0x59, 0x05,
                                        0xd4, 0xb3, 0x66, 0x4d};
static const unsigned char M13[16] = {0x15, 0x3b, 0xc3, 0x67,
                                        0xae, 0xbf, 0x75, 0x5f,
                                        0x57, 0xa7, 0xe4, 0x21, 
                                        0x94, 0x1d, 0x35, 0x6a};
static const unsigned char M20[16] = {0xd5, 0xb1, 0x0d, 0x51,
                                        0xab, 0xb3, 0xad, 0xa9,
                                        0xb0, 0x48, 0xc2, 0x01,
                                        0xc2, 0x9c, 0xc2, 0x14};
static const unsigned char M21[16] = {0x5c, 0x2c, 0x73, 0x73,
                                        0x1e, 0x7d, 0x2d, 0xfd,
                                        0x78, 0x76, 0x75, 0x26,
                                        0x82, 0x65, 0x0e, 0x46};
static const unsigned char M22[16] = {0x17, 0x22, 0x67, 0xd3, 
                                        0x0e, 0x6c, 0x2d, 0x00,
                                        0xff, 0x48, 0x19, 0xd0,
                                        0x68, 0x98, 0x75, 0x7a};
static const unsigned char M23[16] = {0xcf, 0x6e, 0x58, 0x4a,
                                        0x8c, 0xfb, 0x64, 0x2c,
                                        0x6c, 0xd7, 0xca, 0x1b,
                                        0x75, 0xe6, 0x21, 0x18};
static const unsigned char M30[16] = {0xa0, 0x2f, 0x9f, 0x9d,
                                        0xda, 0x69, 0x3c, 0x31,
                                        0x92, 0xf3, 0x24, 0x33,
                                        0x7e, 0x7e, 0xca, 0x47};
static const unsigned char M31[16] = {0xbe, 0xa0, 0xc1, 0xc4,
                                        0x4a, 0x2c, 0x87, 0x9d,
                                        0xdb, 0x18, 0xb6, 0x99,
                                        0x03, 0x03, 0x6b, 0x70};
static const unsigned char M32[16] = {0xbb, 0xa2, 0x70, 0xd1,
                                        0xbc, 0xf7, 0x44, 0xec,
                                        0xcf, 0x05, 0xf1, 0x88,
                                        0x62, 0x60, 0x88, 0x71};
static const unsigned char M33[16] = {0xbf, 0xfe, 0xa5, 0xf8,
                                        0xcc, 0xc8, 0x40, 0x40,
                                        0x49, 0x44, 0xba, 0xdf, 
                                        0x6d, 0xa3, 0xdf, 0x2c};
static const unsigned char f4[16] = {0x72, 0xe1, 0x63, 0x64,
                                    0x9f, 0x9e, 0xad, 0x39,
                                    0x2b, 0xfe, 0x9d, 0xbb, 
                                    0xf8, 0xc3, 0x9c, 0x21};
static const unsigned char f3[16] = {0xe8, 0xf6, 0x8d, 0x18,
                                    0x36, 0xc2, 0x7d, 0xc4,
                                    0x9c, 0x06, 0xb6, 0x48,
                                    0x3f, 0x33, 0x9e, 0x4b};
static const unsigned char f2[16] = {0x35, 0x9a, 0xc3, 0x64,
                                    0xb1, 0xd1, 0x9c, 0x0c,
                                    0x21, 0xcc, 0x9f, 0x6d,
                                    0xe3, 0x99, 0xe7, 0x73};
static const unsigned char f1[16] = {0x6e, 0x8d, 0x4a, 0x1e,
                                    0x79, 0xcd, 0x37, 0xf5,
                                    0x16, 0x2f, 0x0c, 0x8e,
                                    0xe4, 0x6e, 0xdd, 0x1e};

void xADD(unsigned char *r, const unsigned char *x, const unsigned char *y, const unsigned char *p);

void xWRAP(unsigned char *r, const unsigned char *p);

void xUNWRAP(unsigned char *r, const unsigned char *p);

void fast2genPartial(unsigned char *r, const unsigned char *p);

void fast2genFull(unsigned char *r, const unsigned char *p);

void recoverFast(unsigned char *r, const unsigned char *p, const unsigned char *xp, const unsigned char *xq, const unsigned char *xpq);

void recoverGeneral(unsigned char *r, const unsigned char *p, const unsigned char *xp, const unsigned char *xq, const unsigned char *xqp, const unsigned char *xpq); 

// Jacobian
static const unsigned char lambda[16] = {0x52, 0x55, 0x55, 0x55,
                                        0x55, 0x55, 0x55, 0x55,
                                        0x55, 0x55, 0x55, 0x55,
                                        0x55, 0x55, 0x55, 0x15};
static const unsigned char mu[16] = {0x46, 0xa7, 0x19, 0x19,
                                    0xc3, 0x05, 0xa5, 0x05,
                                    0x0e, 0x13, 0x15, 0xb3,
                                    0xfb, 0x34, 0xe3, 0x73};
static const unsigned char nu[16] = {0xf3, 0x21, 0x2d, 0x2d,
                                    0x48, 0x06, 0x58, 0x6b,
                                    0x71, 0x99, 0xf7, 0x3b,
                                    0xb6, 0xb1, 0x2a, 0x55};    
static const unsigned char nulambda[16] = {0xd1, 0x69, 0x46, 0xc6,
                                            0x70, 0x41, 0x69, 0x81,                     
                                            0xc3, 0x44, 0xc5, 0xec,
                                            0x3e, 0xcd, 0xf8, 0x5c};                                     
static const unsigned char mulambda[16] = {0x9f, 0xc3, 0x2e, 0xdb,
                                            0xc0, 0x6d, 0x75, 0x43,
                                            0xfe, 0x98, 0x92, 0xf3,
                                            0xe2, 0x82, 0xb0, 0x3b};                                     

static const unsigned char alphadiv5[16] = {0x7d, 0x93, 0xad, 0xad,
                                            0xec, 0x52, 0xbc, 0x3e,
                                            0xa2, 0xff, 0x85, 0x25,
                                            0x98, 0x8d, 0x52, 0x20};

void copy(unsigned char *r, const unsigned char *x, unsigned long long xlen);

void compress(unsigned char *r, const unsigned char *x);

void decompress(unsigned char *r, const unsigned char *x);

void twodim_scalarmult(unsigned char *r, const unsigned char *P, const unsigned char *xpw, const unsigned char *Q, const unsigned char *n, const unsigned char *m);

void jacobian_scalarmult(unsigned char *r, const unsigned char *n, const unsigned char *p, const unsigned char *xpw);

void project(unsigned char *r, const unsigned char *p);

void ADD(unsigned char *r, const unsigned char *x, const unsigned char *y);

#endif
